# coding: utf-8

"""
    Wavefront Public API

    <p>The Wavefront public API enables you to interact with Wavefront servers using standard web service API tools. You can use the API to automate commonly executed operations such as automatically tagging sources.</p><p>When you make API calls outside the Wavefront API documentation you must add the header \"Authorization: Bearer &lt;&lt;API-TOKEN&gt;&gt;\" to your HTTP requests.</p><p>For legacy versions of the Wavefront API, see the <a href=\"/api-docs/ui/deprecated\">legacy API documentation</a>.</p>

    OpenAPI spec version: v2
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


from pprint import pformat
from six import iteritems
import re


class Chart(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """


    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'units': 'str',
        'name': 'str',
        'description': 'str',
        'base': 'int',
        'chart_settings': 'ChartSettings',
        'sources': 'list[ChartSourceQuery]',
        'no_default_events': 'bool',
        'interpolate_points': 'bool',
        'summarization': 'str',
        'include_obsolete_metrics': 'bool'
    }

    attribute_map = {
        'units': 'units',
        'name': 'name',
        'description': 'description',
        'base': 'base',
        'chart_settings': 'chartSettings',
        'sources': 'sources',
        'no_default_events': 'noDefaultEvents',
        'interpolate_points': 'interpolatePoints',
        'summarization': 'summarization',
        'include_obsolete_metrics': 'includeObsoleteMetrics'
    }

    def __init__(self, units=None, name=None, description=None, base=None, chart_settings=None, sources=None, no_default_events=None, interpolate_points=None, summarization=None, include_obsolete_metrics=None):
        """
        Chart - a model defined in Swagger
        """

        self._units = None
        self._name = None
        self._description = None
        self._base = None
        self._chart_settings = None
        self._sources = None
        self._no_default_events = None
        self._interpolate_points = None
        self._summarization = None
        self._include_obsolete_metrics = None
        self.discriminator = None

        if units is not None:
          self.units = units
        self.name = name
        if description is not None:
          self.description = description
        if base is not None:
          self.base = base
        if chart_settings is not None:
          self.chart_settings = chart_settings
        self.sources = sources
        if no_default_events is not None:
          self.no_default_events = no_default_events
        if interpolate_points is not None:
          self.interpolate_points = interpolate_points
        if summarization is not None:
          self.summarization = summarization
        if include_obsolete_metrics is not None:
          self.include_obsolete_metrics = include_obsolete_metrics

    @property
    def units(self):
        """
        Gets the units of this Chart.
        String to label the units of the chart on the Y-axis

        :return: The units of this Chart.
        :rtype: str
        """
        return self._units

    @units.setter
    def units(self, units):
        """
        Sets the units of this Chart.
        String to label the units of the chart on the Y-axis

        :param units: The units of this Chart.
        :type: str
        """

        self._units = units

    @property
    def name(self):
        """
        Gets the name of this Chart.
        Name of the source

        :return: The name of this Chart.
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """
        Sets the name of this Chart.
        Name of the source

        :param name: The name of this Chart.
        :type: str
        """
        if name is None:
            raise ValueError("Invalid value for `name`, must not be `None`")

        self._name = name

    @property
    def description(self):
        """
        Gets the description of this Chart.
        Description of the chart

        :return: The description of this Chart.
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """
        Sets the description of this Chart.
        Description of the chart

        :param description: The description of this Chart.
        :type: str
        """

        self._description = description

    @property
    def base(self):
        """
        Gets the base of this Chart.
        If the chart has a log-scale Y-axis, the base for the logarithms

        :return: The base of this Chart.
        :rtype: int
        """
        return self._base

    @base.setter
    def base(self, base):
        """
        Sets the base of this Chart.
        If the chart has a log-scale Y-axis, the base for the logarithms

        :param base: The base of this Chart.
        :type: int
        """

        self._base = base

    @property
    def chart_settings(self):
        """
        Gets the chart_settings of this Chart.

        :return: The chart_settings of this Chart.
        :rtype: ChartSettings
        """
        return self._chart_settings

    @chart_settings.setter
    def chart_settings(self, chart_settings):
        """
        Sets the chart_settings of this Chart.

        :param chart_settings: The chart_settings of this Chart.
        :type: ChartSettings
        """

        self._chart_settings = chart_settings

    @property
    def sources(self):
        """
        Gets the sources of this Chart.
        Query expression to plot on the chart

        :return: The sources of this Chart.
        :rtype: list[ChartSourceQuery]
        """
        return self._sources

    @sources.setter
    def sources(self, sources):
        """
        Sets the sources of this Chart.
        Query expression to plot on the chart

        :param sources: The sources of this Chart.
        :type: list[ChartSourceQuery]
        """
        if sources is None:
            raise ValueError("Invalid value for `sources`, must not be `None`")

        self._sources = sources

    @property
    def no_default_events(self):
        """
        Gets the no_default_events of this Chart.
        Whether to hide events related to the sources in the charts produced. Default false (i.e. shows events)

        :return: The no_default_events of this Chart.
        :rtype: bool
        """
        return self._no_default_events

    @no_default_events.setter
    def no_default_events(self, no_default_events):
        """
        Sets the no_default_events of this Chart.
        Whether to hide events related to the sources in the charts produced. Default false (i.e. shows events)

        :param no_default_events: The no_default_events of this Chart.
        :type: bool
        """

        self._no_default_events = no_default_events

    @property
    def interpolate_points(self):
        """
        Gets the interpolate_points of this Chart.
        Whether to interpolate points in the charts produced. Default: true

        :return: The interpolate_points of this Chart.
        :rtype: bool
        """
        return self._interpolate_points

    @interpolate_points.setter
    def interpolate_points(self, interpolate_points):
        """
        Sets the interpolate_points of this Chart.
        Whether to interpolate points in the charts produced. Default: true

        :param interpolate_points: The interpolate_points of this Chart.
        :type: bool
        """

        self._interpolate_points = interpolate_points

    @property
    def summarization(self):
        """
        Gets the summarization of this Chart.
        Summarization strategy for the chart.  MEAN is default

        :return: The summarization of this Chart.
        :rtype: str
        """
        return self._summarization

    @summarization.setter
    def summarization(self, summarization):
        """
        Sets the summarization of this Chart.
        Summarization strategy for the chart.  MEAN is default

        :param summarization: The summarization of this Chart.
        :type: str
        """
        allowed_values = ["MEAN", "MEDIAN", "MIN", "MAX", "SUM", "COUNT", "LAST", "FIRST"]
        if summarization not in allowed_values:
            raise ValueError(
                "Invalid value for `summarization` ({0}), must be one of {1}"
                .format(summarization, allowed_values)
            )

        self._summarization = summarization

    @property
    def include_obsolete_metrics(self):
        """
        Gets the include_obsolete_metrics of this Chart.
        Whether to show obsolete metrics.  Default: false

        :return: The include_obsolete_metrics of this Chart.
        :rtype: bool
        """
        return self._include_obsolete_metrics

    @include_obsolete_metrics.setter
    def include_obsolete_metrics(self, include_obsolete_metrics):
        """
        Sets the include_obsolete_metrics of this Chart.
        Whether to show obsolete metrics.  Default: false

        :param include_obsolete_metrics: The include_obsolete_metrics of this Chart.
        :type: bool
        """

        self._include_obsolete_metrics = include_obsolete_metrics

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if not isinstance(other, Chart):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other
