# coding: utf-8

"""
    Wavefront Public API

    <p>The Wavefront public API enables you to interact with Wavefront servers using standard web service API tools. You can use the API to automate commonly executed operations such as automatically tagging sources.</p><p>When you make API calls outside the Wavefront API documentation you must add the header \"Authorization: Bearer &lt;&lt;API-TOKEN&gt;&gt;\" to your HTTP requests.</p><p>For legacy versions of the Wavefront API, see the <a href=\"/api-docs/ui/deprecated\">legacy API documentation</a>.</p>

    OpenAPI spec version: v2
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


from pprint import pformat
from six import iteritems
import re


class Integration(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """


    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'icon': 'str',
        'metrics': 'IntegrationMetrics',
        'version': 'str',
        'name': 'str',
        'id': 'str',
        'description': 'str',
        'overview': 'str',
        'setup': 'str',
        'dashboards': 'list[IntegrationDashboard]',
        'base_url': 'str',
        'status': 'IntegrationStatus',
        'creator_id': 'str',
        'created_epoch_millis': 'int',
        'updated_epoch_millis': 'int',
        'updater_id': 'str',
        'deleted': 'bool'
    }

    attribute_map = {
        'icon': 'icon',
        'metrics': 'metrics',
        'version': 'version',
        'name': 'name',
        'id': 'id',
        'description': 'description',
        'overview': 'overview',
        'setup': 'setup',
        'dashboards': 'dashboards',
        'base_url': 'baseUrl',
        'status': 'status',
        'creator_id': 'creatorId',
        'created_epoch_millis': 'createdEpochMillis',
        'updated_epoch_millis': 'updatedEpochMillis',
        'updater_id': 'updaterId',
        'deleted': 'deleted'
    }

    def __init__(self, icon=None, metrics=None, version=None, name=None, id=None, description=None, overview=None, setup=None, dashboards=None, base_url=None, status=None, creator_id=None, created_epoch_millis=None, updated_epoch_millis=None, updater_id=None, deleted=None):
        """
        Integration - a model defined in Swagger
        """

        self._icon = None
        self._metrics = None
        self._version = None
        self._name = None
        self._id = None
        self._description = None
        self._overview = None
        self._setup = None
        self._dashboards = None
        self._base_url = None
        self._status = None
        self._creator_id = None
        self._created_epoch_millis = None
        self._updated_epoch_millis = None
        self._updater_id = None
        self._deleted = None
        self.discriminator = None

        self.icon = icon
        if metrics is not None:
          self.metrics = metrics
        self.version = version
        self.name = name
        if id is not None:
          self.id = id
        self.description = description
        if overview is not None:
          self.overview = overview
        if setup is not None:
          self.setup = setup
        if dashboards is not None:
          self.dashboards = dashboards
        if base_url is not None:
          self.base_url = base_url
        if status is not None:
          self.status = status
        if creator_id is not None:
          self.creator_id = creator_id
        if created_epoch_millis is not None:
          self.created_epoch_millis = created_epoch_millis
        if updated_epoch_millis is not None:
          self.updated_epoch_millis = updated_epoch_millis
        if updater_id is not None:
          self.updater_id = updater_id
        if deleted is not None:
          self.deleted = deleted

    @property
    def icon(self):
        """
        Gets the icon of this Integration.
        URI path to the integration icon

        :return: The icon of this Integration.
        :rtype: str
        """
        return self._icon

    @icon.setter
    def icon(self, icon):
        """
        Sets the icon of this Integration.
        URI path to the integration icon

        :param icon: The icon of this Integration.
        :type: str
        """
        if icon is None:
            raise ValueError("Invalid value for `icon`, must not be `None`")

        self._icon = icon

    @property
    def metrics(self):
        """
        Gets the metrics of this Integration.

        :return: The metrics of this Integration.
        :rtype: IntegrationMetrics
        """
        return self._metrics

    @metrics.setter
    def metrics(self, metrics):
        """
        Sets the metrics of this Integration.

        :param metrics: The metrics of this Integration.
        :type: IntegrationMetrics
        """

        self._metrics = metrics

    @property
    def version(self):
        """
        Gets the version of this Integration.
        Integration version string

        :return: The version of this Integration.
        :rtype: str
        """
        return self._version

    @version.setter
    def version(self, version):
        """
        Sets the version of this Integration.
        Integration version string

        :param version: The version of this Integration.
        :type: str
        """
        if version is None:
            raise ValueError("Invalid value for `version`, must not be `None`")

        self._version = version

    @property
    def name(self):
        """
        Gets the name of this Integration.
        Integration name

        :return: The name of this Integration.
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """
        Sets the name of this Integration.
        Integration name

        :param name: The name of this Integration.
        :type: str
        """
        if name is None:
            raise ValueError("Invalid value for `name`, must not be `None`")

        self._name = name

    @property
    def id(self):
        """
        Gets the id of this Integration.

        :return: The id of this Integration.
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """
        Sets the id of this Integration.

        :param id: The id of this Integration.
        :type: str
        """

        self._id = id

    @property
    def description(self):
        """
        Gets the description of this Integration.
        Integration description

        :return: The description of this Integration.
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """
        Sets the description of this Integration.
        Integration description

        :param description: The description of this Integration.
        :type: str
        """
        if description is None:
            raise ValueError("Invalid value for `description`, must not be `None`")

        self._description = description

    @property
    def overview(self):
        """
        Gets the overview of this Integration.
        Descriptive text giving an overview of integration functionality

        :return: The overview of this Integration.
        :rtype: str
        """
        return self._overview

    @overview.setter
    def overview(self, overview):
        """
        Sets the overview of this Integration.
        Descriptive text giving an overview of integration functionality

        :param overview: The overview of this Integration.
        :type: str
        """

        self._overview = overview

    @property
    def setup(self):
        """
        Gets the setup of this Integration.
        How the integration will be set-up

        :return: The setup of this Integration.
        :rtype: str
        """
        return self._setup

    @setup.setter
    def setup(self, setup):
        """
        Sets the setup of this Integration.
        How the integration will be set-up

        :param setup: The setup of this Integration.
        :type: str
        """

        self._setup = setup

    @property
    def dashboards(self):
        """
        Gets the dashboards of this Integration.
        A list of dashboards belonging to this integration

        :return: The dashboards of this Integration.
        :rtype: list[IntegrationDashboard]
        """
        return self._dashboards

    @dashboards.setter
    def dashboards(self, dashboards):
        """
        Sets the dashboards of this Integration.
        A list of dashboards belonging to this integration

        :param dashboards: The dashboards of this Integration.
        :type: list[IntegrationDashboard]
        """

        self._dashboards = dashboards

    @property
    def base_url(self):
        """
        Gets the base_url of this Integration.
        Base URL for this integration's assets

        :return: The base_url of this Integration.
        :rtype: str
        """
        return self._base_url

    @base_url.setter
    def base_url(self, base_url):
        """
        Sets the base_url of this Integration.
        Base URL for this integration's assets

        :param base_url: The base_url of this Integration.
        :type: str
        """

        self._base_url = base_url

    @property
    def status(self):
        """
        Gets the status of this Integration.

        :return: The status of this Integration.
        :rtype: IntegrationStatus
        """
        return self._status

    @status.setter
    def status(self, status):
        """
        Sets the status of this Integration.

        :param status: The status of this Integration.
        :type: IntegrationStatus
        """

        self._status = status

    @property
    def creator_id(self):
        """
        Gets the creator_id of this Integration.

        :return: The creator_id of this Integration.
        :rtype: str
        """
        return self._creator_id

    @creator_id.setter
    def creator_id(self, creator_id):
        """
        Sets the creator_id of this Integration.

        :param creator_id: The creator_id of this Integration.
        :type: str
        """

        self._creator_id = creator_id

    @property
    def created_epoch_millis(self):
        """
        Gets the created_epoch_millis of this Integration.

        :return: The created_epoch_millis of this Integration.
        :rtype: int
        """
        return self._created_epoch_millis

    @created_epoch_millis.setter
    def created_epoch_millis(self, created_epoch_millis):
        """
        Sets the created_epoch_millis of this Integration.

        :param created_epoch_millis: The created_epoch_millis of this Integration.
        :type: int
        """

        self._created_epoch_millis = created_epoch_millis

    @property
    def updated_epoch_millis(self):
        """
        Gets the updated_epoch_millis of this Integration.

        :return: The updated_epoch_millis of this Integration.
        :rtype: int
        """
        return self._updated_epoch_millis

    @updated_epoch_millis.setter
    def updated_epoch_millis(self, updated_epoch_millis):
        """
        Sets the updated_epoch_millis of this Integration.

        :param updated_epoch_millis: The updated_epoch_millis of this Integration.
        :type: int
        """

        self._updated_epoch_millis = updated_epoch_millis

    @property
    def updater_id(self):
        """
        Gets the updater_id of this Integration.

        :return: The updater_id of this Integration.
        :rtype: str
        """
        return self._updater_id

    @updater_id.setter
    def updater_id(self, updater_id):
        """
        Sets the updater_id of this Integration.

        :param updater_id: The updater_id of this Integration.
        :type: str
        """

        self._updater_id = updater_id

    @property
    def deleted(self):
        """
        Gets the deleted of this Integration.

        :return: The deleted of this Integration.
        :rtype: bool
        """
        return self._deleted

    @deleted.setter
    def deleted(self, deleted):
        """
        Sets the deleted of this Integration.

        :param deleted: The deleted of this Integration.
        :type: bool
        """

        self._deleted = deleted

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if not isinstance(other, Integration):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other
